<template>
  <!-- This example requires Tailwind CSS v2.0+ -->
  <!-- Global notification live region, render this permanently at the end of the document -->
  <div
    v-if="notification"
    id="notification"
    aria-live="assertive"
    class="fixed inset-0 z-50 flex items-end justify-center px-4 py-6 pointer-events-none sm:p-6 sm:items-start sm:justify-end"
  >
    <div
      class="w-full max-w-sm overflow-hidden transition duration-300 ease-out transform bg-white rounded shadow-lg pointer-events-auto ring-1 ring-black ring-opacity-5"
    >
      <div class="p-4">
        <div class="flex items-start">
          <div class="flex-shrink-0">
            <i
              v-if="type === 'check'"
              class="text-2xl bx bx-check-circle text-success"
            ></i>
            <i
              v-if="type === 'error'"
              class="text-2xl bx bx-error-circle text-primary-200"
            ></i>
          </div>
          <div class="ml-3 w-0 flex-1 pt-0.5">
            <p class="text-sm font-medium text-gray-900">{{ title }}</p>
            <p v-if="message" class="mt-1 text-sm text-gray-500">
              {{ message }}
            </p>
          </div>
          <div class="flex flex-shrink-0 ml-4">
            <button
              class="inline-flex text-gray-400 bg-white rounded-md hover:text-gray-500 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-indigo-500"
              @click.prevent="unsetNotification"
            >
              <span class="sr-only">Close</span>
              <!-- Heroicon name: solid/x -->
              <svg
                class="w-5 h-5"
                xmlns="http://www.w3.org/2000/svg"
                viewBox="0 0 20 20"
                fill="currentColor"
                aria-hidden="true"
              >
                <path
                  fill-rule="evenodd"
                  d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z"
                  clip-rule="evenodd"
                />
              </svg>
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  computed: {
    notification() {
      return this.$store.state.system.notification || null
    },
    type() {
      return this.$store.state.system.notification?.type
    },
    title() {
      return this.$store.state.system.notification?.title
    },
    message() {
      return this.$store.state.system.notification?.message
    },
    duration() {
      return this.$store.state.system.notification?.duration || 3000
    },
  },
  methods: {
    unsetNotification() {
      this.$store.dispatch('system/unsetNotification')
    },
  },
}
</script>
